#ifndef _HELPFUNCTIONS_H
#define	_HELPFUNCTIONS_H

#include <iostream>
#include <time.h>
#include "Graph.h"
#include <string>

#define PRINT(STR)      std::cout << STR << std::endl
#define PRINTC(STR)     std::cout << STR
#define DEBUG(VAR)      std::cout << #VAR << ": " << VAR << std::endl
#define LONG_SIZE	    sizeof( long )*8
#define INT_SIZE        sizeof( int )*8
#define PRINT_TIME		help::printTime()


namespace verifier { class Graph; }
namespace help {
  using namespace verifier;
  using namespace std;  

  unsigned int getNextSubset( unsigned int );
  unsigned long getNextSubsetLong( unsigned long );
    
  void printInt( int );
  void printLong( long );
    
  bool trickleArray( unsigned int*, unsigned int );
  void printTime();

  int fac(int);

  bool checkGraph( Graph& g, int orbit1Min, int orbit1Max, int orbit2Min, int orbit2Max, int minDegree, int maxDegree );

  bool fileExists(string fileName);
}

#endif	/* _HELPFUNCTIONS_H */

