#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "HelpFunctions.h"
#include "Graph.h"
#include "collection/List.h"

using namespace collection;
using namespace verifier;

int main(int argc, char** argv) {

   List<branching> vectors;

   if (argc < 2){
      PRINT("Not enough arguments");
      return 0;
   }

   ifstream branchingVectors;
   branchingVectors.open(argv[1], ios::in|ios::binary|ios::ate);
   ifstream::pos_type size = branchingVectors.tellg();
   PRINT("File size: " << size);

   PRINT("BRANCHING SIZE: " << BRANCHING_SIZE);
   
   if (size % (BRANCHING_SIZE*4) != 0){
      PRINT("The Padding of the file is not correct, judging by the size of the file. Aborting");
      return 0;
   }

   branchingVectors.seekg(0, ios::beg);
   while (branchingVectors.tellg() < size) {

      branching mirrors;
      branching satelites;
      char tmp[BRANCHING_SIZE];

      // Reading 'mirrors' branching.
      branchingVectors.read(tmp, BRANCHING_SIZE);
      for (int i = 0; i < BRANCHING_SIZE; i++)
	 mirrors.takeIt[i] = tmp[i];

      branchingVectors.read(tmp, BRANCHING_SIZE);
      for (int i = 0; i < BRANCHING_SIZE; i++)
	 mirrors.leaveIt[i] = tmp[i];
      
      // Reading satelites branching.
      branchingVectors.read(tmp, BRANCHING_SIZE);
      for (int i = 0; i < BRANCHING_SIZE; i++)
	 mirrors.takeIt[i] = tmp[i];

      branchingVectors.read(tmp, BRANCHING_SIZE);
      for (int i = 0; i < BRANCHING_SIZE; i++)
	 mirrors.leaveIt[i] = tmp[i];
      
      if (branchingVectors.fail())
	 PRINT ("ERROR: Somehow the program managed to get out of the padding structure!");
    
   }

   branchingVectors.close();

   PRINT("All done.");
   return 0;
  
}
