#ifndef _FASTGRAPHCOLLECTION_H
#define	_FASTGRAPHCOLLECTION_H

#include <iostream>
#include <list>
#include "List.h"
#include "../HelpFunctions.h"
#include "../Graph.h"
#include "../shared/AdjacencyMatrix.h"
#include "../shared/BitVector.h"
#include "ArrayPool.h"

namespace collection {

   using namespace std;
   using namespace shared;
   using namespace verifier;

   class FastGraphCollection {
   private:
      static int** permutationTables;

      List<Graph*> graphs;
      int isoTests;

      bool flagGraph( Graph* );	
      bool compare( Graph*, Graph*, int*, int, int );
      bool checkPermutation( Graph*, Graph*, int*, int );
      int* getPermutationTable( int );
      int* generatePermutationTable( int );
		
   public:
      FastGraphCollection();
      ~FastGraphCollection();

      unsigned int size() const;
      bool flag( const Graph& );	// returns whether the graph could be flagged
      bool insert( const Graph&, bool deleteOne);// returns whether graph was really inserted (if it returns false the graph was already in this collection)
      bool contains( const Graph& );
      void clear();   // deletes all entries

      int allFlagged(List<Graph*>* notFlagged);

      bool empty();
	  Graph* peek();
      void pop();
   };

}

#endif	/* _FASTGRAPHCOLLECTION_H */
