#include <stdlib.h>
#include <iostream>
#include <sstream>
#include <string.h>
#include <assert.h>
#include "HelpFunctions.h"
#include "collection/List.h"
#include "Graph.h"


using namespace shared;
//  using namespace help;
using namespace std;
using namespace verifier;
using namespace collection;

string filename; // just so this compiles (needed by fist.cpp)

int main(int argc, char** argv) {

	char* graphFile;
	bool inputOkay = true;

	if (argc < 2) {
		inputOkay  = false;
	} else {
		graphFile = argv[1];
	}

	if ( !inputOkay ) {
		PRINT("convert <graph file>");
		PRINT("output is written to {file name}_conv");
		return 1;
	}

	ostringstream temp;
	temp << graphFile << "_conv";

	string newFileName = temp.str();

	ofstream* out = new ofstream( newFileName.c_str(), ios::binary );

	ByteReader in( graphFile, true );	// reverse byte-reader
	int counter = 0;
	while( !in.end() ) {
		Graph current( in );
		current.encodeToFile( out );
		counter++;
	}
	PRINT( "Converted " << counter << " graphs and wrote them to " << newFileName );


	out->flush();
	out->close();
	delete out;

	return 0;
}
