#include "ByteReader.h"
#include <fstream>
#include <iostream>
#include <assert.h>

using namespace std;

ByteReader::ByteReader( char* file, bool reverse  ) : reverse( reverse ) { 
	newFile( file );
}

int ByteReader::getNumber( int size ) {

	int number = 0;

	if ( reverse ) {
		for ( int i = 0; i < size; ++i ){

			if ( position == 8 ){
				file->get(actual);
				position = 0;
			}

			number |= ( ( ( ( 1 <<  7  ) &  actual  ) ? 1 : 0 ) << i );
			actual <<= 1;
			position++;

		}

	} else {
		for ( int i = size - 1; i >= 0; --i ){

			if ( position == 8 ){
				file->get(actual);
				position = 0;
			}

			number |= ( ( ( ( 1 <<  7  ) &  actual  ) ? 1 : 0 ) << i );
			actual <<= 1;
			position++;

		}
	}

	return number;
}

void ByteReader::flush(){

	file->get(actual);
	position = 0;

}

void ByteReader::newFile( char* fileName ){
	cout << "Reading from " << fileName << endl;
	file = new ifstream(fileName, ios::binary);
	position = 8;
	actual  = 0;
	assert( file->is_open() ); 

}

streampos ByteReader::tellg(){

	return file->tellg();

}

void ByteReader::seekg( streampos pos ){

	file->seekg( pos );

	position = 0;
	file->get(actual);

}

bool ByteReader::end(){

	return file->eof();

}

void ByteReader::close(){
	if ( file != 0 ){
		file->close();
		delete file;
		file = 0;
	}
}

ByteReader::~ByteReader(){
	if ( file != 0 ){
		file->close();
		delete file;
	}
}
