#include <stdlib.h>
#include <iostream>

#include "collection/GraphTrie.h"
#include "HelpFunctions.h" 

#include <time.h>

using namespace std;
using namespace verifier;
using namespace help;
using namespace collection;

string filename;	// otherwise this won't compile

Graph* createRandomPermutation( Graph* g );
Graph* createRandomGraph( int orbit1, int orbit2 );

int main(int argc, char** argv) {

	Graph test( 4, 6);
	test.setEdge( 0, 1 );
	test.setEdge( 0, 2 );
	test.setEdge( 0, 3 );
	test.setEdge( 0, 4 );

	test.setEdge( 3, 4 );

	test.setEdge( 1, 5 );
	test.setEdge( 2, 5 );
	test.setEdge( 2, 6 );
	test.setEdge( 2, 7 );
	test.setEdge( 3, 8 );
	test.setEdge( 4, 9 );
	test.setEdge( 4, 10 );
	
	test.setEdge( 6, 7 );
	test.setEdge( 8, 9 );
	test.setEdge( 5, 10 );

	test.setAnonymousEdges( 5, 0 );
	test.setAnonymousEdges( 6, 1 );
	test.setAnonymousEdges( 7, 1 );
	test.setAnonymousEdges( 8, 2 );
	test.setAnonymousEdges( 9, 1 );
	test.setAnonymousEdges( 10, 2 );

	test.print();

	test.swapVertices( 1, 3 );

	test.print();

	// test.branchWithMirrors().print();

	PRINT( "" );

	// test.branchWithSatellites().print();

	return 0;
	
	
	/*
	// Loads a graph file and display various information
	if ( argc < 2 )
		PRINT( "test <graph file>" );

	int orbit1Min, orbit1Max, orbit2Min, orbit2Max, minDegree, maxDegree;
	int minVertices, maxVertices, counter;

	orbit1Min = orbit2Min = minDegree = minVertices = 999;
	orbit1Max = orbit2Max = maxDegree = maxVertices = -1;
	counter = 0;
	
	ByteReader in( argv[1] );
	while( !in.end() ) {
		Graph current( in );

		if( current.size() == 0 )
			break;
	
		minVertices = current.size() < minVertices ? current.size() : minVertices;
		maxVertices = current.size() > maxVertices ? current.size() : maxVertices;

		orbit1Min = current.orbit1 < orbit1Min ? current.orbit1 : orbit1Min;
		orbit1Max = current.orbit1 > orbit1Max ? current.orbit1 : orbit1Max;

		orbit2Min = current.orbit2 < orbit2Min ? current.orbit2 : orbit2Min;
		orbit2Max = current.orbit2 > orbit2Max ? current.orbit2 : orbit2Max;

		for( int i = 0; i < current.size(); ++i ) {
			int deg = current.getDegree(i);
			minDegree = deg < minDegree ? deg : minDegree;
			maxDegree = deg > maxDegree ? deg : maxDegree;		
		}

		bool hasEdgeInOrbit1 = false;
		for( int i = 1; i <= current.orbit1 && !hasEdgeInOrbit1; ++i ) {
			for( int j = 1; j <= current.orbit1 && !hasEdgeInOrbit1; ++j ) {
				hasEdgeInOrbit1 = current.adjacent( i, j );
			}
		}

		bool hasAnonymousEdges = false;
		for( int i = current.orbit1+1; i <= current.size() && !hasAnonymousEdges; ++i ) {
			hasAnonymousEdges = current.getAnonymousEdges(i) > 0;
		}

		++counter;
		if ( hasAnonymousEdges )
			current.print();
		continue;

		// For branch testing
		if( !hasEdgeInOrbit1 )
			continue;

		branching brMirrors = current.branchWithMirrors();
		branching brSatellites = current.branchWithSatellites();

		bool interesting = false;
		for( int i = 0; i < BRANCHING_SIZE; ++i )
			interesting = (brMirrors.takeIt[i] != brSatellites.takeIt[i]) || interesting;
		
		if ( !interesting ) continue; 

		interesting = false;
		for( int i = 0; i < BRANCHING_SIZE; ++i )
			interesting = (brMirrors.leaveIt[i] != brSatellites.leaveIt[i]) || interesting;


		if( interesting ) {
			current.print();
			brMirrors.print();
			brSatellites.print();
		}
	}
	*/
	/*
	// Creates random graphs and fills memory
   srand( time( 0 ) );

   int orbit1 = 4;
   int orbit2 = 7;

   GraphTrie graphs( orbit1, orbit1, orbit2, orbit2, 0 );
   int counter = -1;

   while (true){
	   Graph* g = createRandomGraph( orbit1, orbit2 );
	   graphs.insert( *g );
	
		g->print();

	   if ( ++counter % 100 == 0 )
		   PRINT(counter);
   }
   */

/*
// TEST: Output all permutations of a given graph.

int orbit1 = 3;
int orbit2 = 2;

Graph* g = createRandomGraph( orbit1, orbit2 );

GraphTrie graphs( orbit1, orbit1, orbit2, orbit2 );
graphs.insert( *g );

PRINT( "Using graph:" );
g->print();

PRINT( "\n" );

assert( graphs.contains( *g ) );

List<Graph> iso;
while( iso.size() < 7 ) {
Graph* h = createRandomGraph( orbit1, orbit2 );

if ( graphs.contains( *h ) && !(*h == *g) ) {
bool contained = false;
for( List<Graph>::iterator it = iso.begin(); it != iso.end() && !contained; ++it ) {
contained = (*h == *it); 
}

if ( !contained ) {
iso.push( *h );
PRINT( "Found " << iso.size() );
}
}

delete h;
}

for( List<Graph>::iterator it = iso.begin(); it != iso.end(); ++it ) {
(*it).print();
}


delete g;

/* */ // ------------------------------------------------------------------------------------------------------ // 








/*
// TEST: Output all permutations of a given graph.

Graph g( 4, 0 );	

g.setEdge( 1, 2 );
g.setEdge( 2, 3 );
g.setEdge( 3, 4 );
g.setEdge( 4, 1 );

PRINT( "Graph used: " );
g.print();

PRINT( "\n" );

Permutations pi( 4, 4, 0, 0 );	
PermutationEnumerator& perm = pi.getPermutationEnumerator( 4, 0 );	
PRINT( "Printing " << perm.numberOfPermutations() << " permutations" );

GraphTrie graphs( 4, 4, 0, 0, 0 );
int graphCounter = 0;

while( perm.hasMore() ) {
Graph* current = perm.next( g );
current->print();
PRINT( "" );

if ( !graphs.contains( *current ) ) {
graphs.insert( *current );
graphCounter++;
}

delete current;
}

PRINT( "Found " << graphCounter << " different permutations for this graph." );

/* */ // ------------------------------------------------------------------------------------------------------ // 





/*
// TEST: Create graph, put it into a GraphTrie and check whether all permutations whill be deteced correctly.

int orbit1 = 4;
int orbit2 = 5;

Graph g( orbit1, orbit2 );
GraphTrie trie( 3, 4, 1, 7 );	
Permutations pi( 3, 4, 1, 7 );	

srand( time( 0 ) );

// Create graph
for( int i = 1; i <= orbit1; ++i ) {
g.setEdge( 0, i );
}

// Random orbit1 Edges
for( int i = 0; i < rand()%(orbit1*orbit1); ++i ) {
int v = 1+rand()%orbit1;
int w = 1+rand()%orbit1;
if ( v == w ) continue;
if ( g.adjacent( v,w ) ) continue;
g.setEdge( v,w );
}

// Attach orbit1 to orbit2
for( int i = 1; i <= orbit1; ++i ) {
g.setEdge( i, i+orbit1 );
}

for( int i = orbit1+orbit1+1; i < 1+orbit1+orbit2; ++i ) {
g.setEdge( 1+rand()%orbit1, i );
}

// Random orbit2 Edges
for( int i = 0; i < rand()%(orbit2*orbit2); ++i ) {
int v = 1+orbit1+rand()%orbit2;
int w = 1+orbit1+rand()%orbit2;
if ( v == w ) continue;
if ( g.adjacent( v,w ) ) continue;
g.setEdge( v,w );
}

// Random anonymous edges
for( int i = 1+orbit1; i < 1+orbit1+orbit2; ++i ) {
g.setAnonymousEdges( i, rand()%4 );
}

PRINT( "Graph used:" );
g.print();

// Insert graph
trie.insert( g );
assert( trie.contains( g ) );

// Check permutations
PermutationEnumerator& perm = pi.getPermutationEnumerator( orbit1, orbit2 );	
assert( perm.numberOfPermutations() == fac(orbit1) * fac(orbit2) );

PRINT( "Checking " << perm.numberOfPermutations() << " permutations" );

while( perm.hasMore() ) {
Graph* current = perm.next( g );
assert( trie.contains( *current ) && trie.flag( *current ) );
delete current;
}
assert( trie.allFlagged() );

PRINT( "All okay." );

/* */ // ------------------------------------------------------------------------------------------------------ // 





/*
// TEST: Put random graphs into trie and test whether random permutations of them are detected correctly.
PRINT("Testing");

GraphTrie trie( 3, 3, 3, 6 );
List<Graph> generated;

srand( time(0) );

for( int i = 0; i < 10000; ++i ) {
int orbit1 = 3;
int orbit2 = rand()%4 + 3;
int size = orbit1+orbit2+1;
Graph g( orbit1, orbit2 );

for( int j = 0; j < rand()%100 + 1; ++j) {
int v = rand()%size;
int w = rand()%size;
if ( v == w ) continue;
if ( g.adjacent( v,w ) ) continue;
g.setEdge( v,w );
}

// Don't insert duplicates, as the flagging won't work then.
if ( !trie.contains( g ) ) {
trie.insert( g );
assert (trie.contains(g));
generated.push( g );
}
}

//trie.clear();

PRINT("Checking...");

for( List<Graph>::iterator i = generated.begin(); i != generated.end(); ++i ) {
Graph g( *i );

for( int v = 1; v < g.orbit1+1; ++v) {
g.swapVertices( v, rand()%(g.orbit1) + 1 );
} 

assert( trie.contains( g ) );
assert( trie.flag( g ) );
}

assert( trie.allFlagged() );

PRINT( "All okay.");

/* */ // ------------------------------------------------------------------------------------------------------ // 
}

Graph* createRandomPermutation( Graph* g ) {
	Graph* h = new Graph( *g );

	int orbit1 = h->orbit1;
	int orbit2 = h->orbit2;
	int n = 1+orbit1+orbit2;

	int* perm = new int[ n ];
	for( int i = 0; i < n; ++i )
		perm[i] = i;

	// Random swaps in orbit1.
	for( int i = 0; i < rand()%(orbit1*orbit1); ++i ) {
		int v = 1+rand()%orbit1;
		int w = 1+rand()%orbit1;
		if ( v == w ) continue;

		h->swapVertices( v, w );
		perm[v] ^= perm[w] ^= perm[v] ^= perm[w];	
	}

	// Random swaps in orbit2.
	for( int i = 0; i < rand()%(orbit2*orbit2); ++i ) {
		int v = 1+orbit1+rand()%orbit2;
		int w = 1+orbit1+rand()%orbit2;
		if ( v == w ) continue;

		h->swapVertices( v, w );	
		perm[v] ^= perm[w] ^= perm[v] ^= perm[w];	
	}

	// Print permutation
	/*
	   for( int i = 0; i < n; ++i )
	   cout << perm[i] << ", ";
	   cout << endl;
	   */

	return h;
}

Graph* createRandomGraph( int orbit1, int orbit2 ) {
	Graph* g = new Graph( orbit1, orbit2 );

	// Create graph
	for( int i = 1; i <= orbit1; ++i ) {
		g->setEdge( 0, i );
	}

	// Random orbit1 Edges
	for( int i = 0; i < rand()%(orbit1*orbit1); ++i ) {
		int v = 1+rand()%orbit1;
		int w = 1+rand()%orbit1;
		if ( v == w ) continue;
		if ( g->adjacent( v,w ) ) continue;
		g->setEdge( v,w );
	}

	// Attach orbit1 to orbit2
	for( int i = 1; i <= orbit1 && i+orbit1 < 1+orbit1+orbit2; ++i ) {
		g->setEdge( i, i+orbit1 );
	}

	for( int i = orbit1+orbit1+1; i < 1+orbit1+orbit2; ++i ) {
		g->setEdge( 1+rand()%orbit1, i );
	}

	// Random orbit2 Edges
	for( int i = 0; i < rand()%(orbit2*orbit2); ++i ) {
		int v = 1+orbit1+rand()%orbit2;
		int w = 1+orbit1+rand()%orbit2;
		if ( v == w ) continue;
		if ( g->adjacent( v,w ) ) continue;
		g->setEdge( v,w );
	}

	// Random anonymous edges
	for( int i = 1+orbit1; i < 1+orbit1+orbit2; ++i ) {
		g->setAnonymousEdges( i, rand()%4 );
	}

	// Random swaps in orbit1.
	for( int i = 0; i < rand()%(orbit1*orbit1); ++i ) {
		int v = 1+rand()%orbit1;
		int w = 1+rand()%orbit1;
		if ( v == w ) continue;

		g->swapVertices( v, w );	
	}

	// Random swaps in orbit2.
	for( int i = 0; i < rand()%(orbit2*orbit2); ++i ) {
		int v = 1+orbit1+rand()%orbit2;
		int w = 1+orbit1+rand()%orbit2;
		if ( v == w ) continue;

		g->swapVertices( v, w );	
	}

	return g;
}
